// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "okna.h"

#include "MainFrm.h"
#include "SwitchDlg.h"
#include "HostDlg.h"
#include "LinkDlg.h"
#include "ServerDlg.h"
#include "THost.h"

#include "GUI/InfoView.h"
#include "GUI/EntityView.h"
#include "GUI/WorkSpaceView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_Menu, &CMainFrame::OnMenu)
	ON_COMMAND(ID_Menu32772, &CMainFrame::OnMenu32772)
	ON_COMMAND(ID_VIEW_SERVER, &CMainFrame::OnViewServer)
	ON_COMMAND(ID_VIEW_LINK, &CMainFrame::OnViewLink)
	ON_COMMAND(ID_VIEW_THOST, &CMainFrame::OnViewThost)
	ON_WM_SIZE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		 | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_MINIMIZE | WS_SYSMENU;

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers




void CMainFrame::OnMenu()
{
	
	//MessageBox("HI KIRSO","HI",0);
	CSwitchDlg sw;
	sw.DoModal();
	// TODO: Add your command handler code here
}

//handler for Host
void CMainFrame::OnMenu32772()
{
     CHostDlg host;
	 host.DoModal();

	// TODO: Add your command handler code here
}

void CMainFrame::OnViewServer()
{

     CServerDlg server;
	 server.DoModal();
	// TODO: Add your command handler code here
}

void CMainFrame::OnViewLink()
{
     CLinkDlg link;
	 link.DoModal();

	// TODO: Add your command handler code here
}

void CMainFrame::OnViewThost()
{

	CTHost thost;
	thost.DoModal();

	// TODO: Add your command handler code here
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	// TODO: Add your specialized code here and/or call the base class
	CRect cr;
	GetWindowRect( &cr );

	if (!m_verSplitter.CreateStatic(this, 1, 2))
	{
		TRACE0("Failed to CreateStaticSplitter\n");
		return FALSE;
	}

	if (!m_verSplitter.CreateView(0, 0, RUNTIME_CLASS(CEntityView), CSize(0, 0), pContext))
	{
		TRACE0("Failed to create first pane\n");
		return FALSE;
	}

	m_verSplitter.SetColumnInfo(0, 100, 0);

	if (!m_horSplitter.CreateStatic(&m_verSplitter, 2, 1, WS_CHILD | WS_VISIBLE, m_verSplitter.IdFromRowCol(0, 1)))
	{
		TRACE0("Failed to CreateStaticSplitter\n");
		return FALSE;
	}
	if (!m_horSplitter.CreateView(0, 0, RUNTIME_CLASS(CWorkSpaceView)/*pContext->m_pNewViewClass*/, CSize(0, (cr.Height()/3)*2), pContext))
	{
		TRACE0("Failed to create second pane\n");
		return FALSE;
	}
	if (!m_horSplitter.CreateView(1, 0, RUNTIME_CLASS(CInfoView), CSize(0, 0), pContext))
	{
		TRACE0("Failed to create third pane\n");
		return FALSE;
	}

	return TRUE;
}

void CMainFrame::OnSize(UINT nType, int cx, int cy)
{
	CFrameWnd::OnSize(nType, cx, cy);
	
	
	// TODO: Add your message handler code here
}
